module mod_mat
implicit none

Contains
!> matrix-matrix product
!! @param [in] n dimension
!! @param [in] a matrix
!! @param [in] b matrix
!! @return c matrix with c = a*b
subroutine matmul(n,a,b,c)
  implicit none  ! on force l'initialisation de toutes les variables
  integer, intent(in)       :: n
  real(kind=kind(1.d0)), intent(in)    :: a(n,n),b(n,n)
  real(kind=kind(1.d0)), intent(out)   :: c(n,n)
  integer    :: i,j,k,ii,jj,kk
  integer    :: is

  c = 0.
  is = 20
  do j = 1,n,is
     do i = 1,n,is
        do k = 1,n,is
           do jj = j,min(n,j+is-1)
              do ii = i,min(n,i+is-1)
                 do kk = k,min(n,k+is-1)
                    c(ii,jj) = c(ii,jj) + a(ii,kk)*b(kk,jj)
                 end do
              end do
           end do
        end do
     end do
  end do

end subroutine matmul
end module mod_mat
