!> @file      tp_opt_doc.f90
!! @author    MELIANI
!!
!! ### Institution
!! Observatoire de Paris
!!
!! ### adress
!! Meudon
!!
!! @version   1.0
!! @date      12 Mars 2019
!! @brief     TP du cours optimisation
!!
!! @details   Ce programme permet de mettre en pratique
!!            les notions vues pendant le cours
!!            Calcul de la norme
!!            \f[
!!            \Vert (A \times B) \times x \Vert
!!            \f]
!!            avec A et B matrices et x vecteur
!!
!! @todo Ajouter un type vector
!!
!!
!!
!! @section intro Introduction
!!     This code it use to learn Doxygen with fortran
!! @section optims Optimisations
!!    \subsection loops Les boucles
!!       blablabla
!!    \subsection cstes Les constantes
!!       blablabla
!!
!!       lien avec les boucles: voir \ref loops
!! @section install Installation
!!    Voir le fichier <a href="../../INSTALL">INSTALL</a>

program tp_opt_ok
  use mod_initialise
  use mod_mat
  use mod_scalapackfx_tools
  implicit none  ! on force l'initialisation de toutes les variables

  !> @typedef Matrix
  !! @param n matrix dimension
  !! @param val matrix value
  type Matrix
     integer                               ::  n
     real(kind=8), pointer, dimension(:,:) :: val
     type(initvar)                         :: initvaria
  end type Matrix

  real(kind=kind(1.d0)), allocatable    :: a(:,:),b(:,:)
  real(kind=kind(1.d0)), allocatable    :: c(:,:)  ! c = A*B
  real(kind=kind(1.d0)), allocatable    :: x(:)
  real(kind=kind(1.d0))                 :: ddot

  integer                               :: n  ! taille des matrices



  n = 1000

  ! initialisation des matrices
  allocate(a(n,n))
  call initA(n,a)
  allocate(b(n,n))
  call initB(n,b)

  ! Multiplication A*B
  allocate (c(n,n))
  call matmul(n,a,b,c)

  ! initialisation de x
  allocate(x(n))
  call initX(n,x)

  ! Produit matrice vecteur: x = C*x
  call matvec(n,c,x)

  ! Calcul de la norme
  call norm(n,x)

end program tp_opt_ok
